# COMPUTATION OF 1 BAYES FACTOR FOR THE TEST OF SYMMETRY #

library(Directional)
source("fun_G_0abs.R")
source("mixture.R")


s <- 1e4

# 1. insert the values of the hyperparameters m1, k1 and k2

s3 <- readline(prompt = "insert the  value of m1: ")
m1 <- eval(parse(text = s3))

s4 <- readline(prompt = "insert the  value of k1: ")
k1 <- eval(parse(text = s4))

s5 <- readline(prompt = "insert the  value of k2: ")
k2 <- eval(parse(text = s5))

# 2. fix the values of the hyperparameters nu1, nu2 and tau and xi for the prior of delta

s1 <- readline(prompt = "insert the  value of tau: ")
tau <- eval(parse(text = s1))

s2 <-  readline(prompt = "insert the  value of nu: ")
nu1 <- eval(parse(text = s2))

s2_prime <-  readline(prompt = "insert the  value of nu2: ")
nu1 <- eval(parse(text = s2_prime))

s2_pprime <- readline(prompt = "insert the  value of xi: ")
xi <- eval(parse(text = s2_pprime))


# 3. insert real data ''theta''

s6 <- readline(prompt = "insert the data as a vector of length n: ")
theta <- eval(parse(text = s6))

n <- length(theta)


f <- function(x1,x2) (1/(2*pi*G0_abs(x2,k1,k2)))*exp(k1*cos(x1 - m1)+k2*cos(2*(x1-((m1 - x2)%%pi))))

# calculations of the prior probabilities #

epsilon <- 0.05

I_0 <- function(x) (1/(2*pi))*(integrate(function(phi) exp(x*cos(phi)),0,2*pi)$value)
ff1 <- function(x) (1/(pi*I_0(tau)))*exp(tau*cos(2*(x-nu1)))
ff2 <- function(x) (1/(pi*I_0(tau)))*exp(tau*cos(2*(x-nu2)))
ff <- function(x) xi*ff1(x)+(1-xi)*ff2(x)

p_0 <- (integrate(function(x) ff(x), 0,epsilon/2)$value)+(integrate(function(x) ff(x), pi-epsilon/2,pi)$value)  # p_0=P_0[delta=0] #

p_pi2 <- integrate(function(x) ff(x), pi/2-epsilon/2,pi/2+epsilon/2)$value  # p_p2=P_0[delta=pi/2] #

####################################################

# NOMINATOR #

# calculation of the nominator of the BF #

NN1 <- rep(0,n)
NN2 <- rep(0,n)

for (i in 1:n) {
    NN1[i] <- f(theta[i],0)
    NN2[i] <- f(theta[i],pi/2)
}

N1 <- prod(NN1)
N2 <- prod(NN2)
  
N <- p_0*N1 + p_pi2*N2    # nominator #

############################

# DENOMINATOR #

# calculation of the denominator of the BF #

# test on delta #

# 4. generate a sample of size s of prior values for delta, used for the MonteCarlo method

delta <- mixture(s,xi,nu1,nu2,tau)  # prior values of delta #

index <- ((delta > epsilon/2 & delta < pi/2-epsilon/2) | (delta > pi/2+epsilon/2 & delta < pi-epsilon/2))
delta <- delta[index]

# ----------------------------


tmp <- rep(0, n)
D1 <- rep(0, length(delta))


  for (k in 1:length(delta)) {
    for (i in 1:n) {
      tmp[i] <- f(theta[i],delta[k])
    }
    D1[k] <- prod(tmp)
  }
  D2 <- sum(D1)/s


D <- (p_0+p_pi2)*D2   # denominator #

## BAYES FACTOR ##

BF <- N/D

